;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname battleship-data) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #t #t none #f ())))
(require "provide.rkt")
(provide (all-defined-out))

;; A home-view is a list-of-boat
;;   where the boats do not overlap

;; A boat is a list-of-peg
;;  where the pegs are adjacent and in a row/column

;; A hpeg is
;;   (make-hpeg posn boolean)
;; where posn is on the board, indexing from 0
;; and the boolean is untouched (false) or hit (true)
(define-struct hpeg (loc hit?))

;; An away-view is a list-of-apeg

;; An apeg is
;;   (make-apeg posn boolean)
;; where posn is on the board, indexing from 0
;; and the boolean is miss (false) or hit (true)
(define-struct apeg (loc hit?))

;; A board is 
;;  (make-board away-view home-view boolean string)
(define-struct board (away home my-turn? msg))

;; A response is either
;;   - 'miss
;;   - 'hit
;;   - number (how big the boat was)

(define (response? r)
  (or (eq? r 'miss)
      (eq? r 'hit)
      (number? r)))

;; The size of a cell on the screen:
(define CELL-SIZE 16)

;; Dimension of a view in cells:
(define COLS 10)
(define ROWS 10)

(define boat-2 (list (make-hpeg (make-posn 5 6) #t)
                     (make-hpeg (make-posn 5 7) #f)))
(define boat-3 (list (make-hpeg (make-posn 0 0) #f)
                     (make-hpeg (make-posn 1 0) #f)
                     (make-hpeg (make-posn 2 0) #f)))
(define boat-3-after-hit (list (make-hpeg (make-posn 0 0) #f)
                               (make-hpeg (make-posn 1 0) #f)
                               (make-hpeg (make-posn 2 0) #t)))

(define home-view-1 (list boat-2 boat-3))

(define away-view-1 (list (make-apeg (make-posn 0 0) #f)
                          (make-apeg (make-posn 0 1) #f)
                          (make-apeg (make-posn 0 2) #t)))

(define board-1 (make-board away-view-1 home-view-1 #f ""))
(define board-1-hi (make-board away-view-1 home-view-1 #f "Hi"))
(define board-1a (make-board away-view-1 home-view-1 #t ""))

;; fire-msg? : s-exp -> boolean
(define (fire-msg? msg)
  (and (list? msg)
       (= 3 (length msg))
       (eq? 'fire (first msg))
       (number? (second msg))
       (number? (third msg))))

;; fire-response-msg? : s-exp -> boolean
(define (fire-response-msg? msg)
  (and (list? msg)
       (= 4 (length msg))
       (eq? 'response (first msg))
       (response? (second msg))
       (number? (third msg))
       (number? (fourth msg))))


