;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname battleship-mouse) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #t #t none #f ())))
(require 2htdp/universe)
(require "battleship-data.rkt")
(require "provide.rkt")
(provide handle-board-mouse)

;; A board-or-package
;;  - board
;;  - (make-package board (list 'fire num num))

;; is-peg-filled? : list-of-apeg num num -> boolean
(define (is-peg-filled? a cx cy)
  (ormap (lambda (ap) (equal? (apeg-loc ap) (make-posn cx cy)))
         a))

(check-expect (is-peg-filled? empty 0 0) false)
(check-expect (is-peg-filled? away-view-1 0 0) true)
(check-expect (is-peg-filled? away-view-1 1 0) false)

;; handle-board-mouse : board num num mouse-event -> board-or-package
(define (handle-board-mouse b x y evt)
  (cond
    [(and (board-my-turn? b) 
          (string=? evt "button-down")
          (<= 0 x) (<= 0 y)
          (< x (* COLS CELL-SIZE)) (< y (* ROWS CELL-SIZE)))
     (local [(define cx (quotient x CELL-SIZE))
             (define cy (quotient y CELL-SIZE))]
       (cond
         [(is-peg-filled? (board-away b) cx cy)
          b]
         [else
          (make-package (make-board (board-away b)
                                    (board-home b)
                                    #f
                                    "")
                        (list 'fire cx cy))]))]
    [else b]))

(check-expect (handle-board-mouse board-1 0 0 "button-down")
              board-1)
(check-expect (handle-board-mouse board-1-hi 0 0 "button-down")
              board-1-hi)
(check-expect (handle-board-mouse board-1a 0 0 "button-down")
              board-1a)
(check-expect (handle-board-mouse board-1a CELL-SIZE 0 "button-down")
              (make-package board-1
                            (list 'fire 1 0)))
(check-expect (handle-board-mouse (make-board away-view-1 home-view-1 #t "Hi")
                                  CELL-SIZE 0 "button-down")
              (make-package board-1
                            (list 'fire 1 0)))
(check-expect (handle-board-mouse board-1a CELL-SIZE 1 "button-down")
              (make-package board-1
                            (list 'fire 1 0)))
(check-expect (handle-board-mouse board-1a 0 (* CELL-SIZE ROWS) "button-down")
              board-1a)
(check-expect (handle-board-mouse board-1a -1 0 "button-down")
              board-1a)
